                                ;   PIC- 

;          (), 
;     ""     .
;          , 
;          .
;          , 
;          . 
;            
;     . ,      
; ,   .
;           (  )
;      ( )    ( ). 
;          
;      ,         9 .
;  RB1 (. 7)      ()
;      ,  RA1 (. 18)    
;         6     (  ) 

        ;   - 4
        processor 16f84
        include	<p16f84.inc>
   __CONFIG  _CP_OFF & _WDT_OFF & _PWRTE_ON & _XT_OSC ;  
        errorlevel      -302
        CBLOCK  0CH
        LOOP2		;              
        LOOP1           ;
        FLAG            ;  
        r9s             ;   9 
        r6s             ;   6   
        PULSE
        ENDC

DOOR    EQU  2
START_P EQU  0
START_N EQU  2
ACC     EQU  3 
          
                  
	Org	H'0000'	        ;     
	GOTO	MAIN            ;  
        Org	H'0004'	        ;     
	GOTO	STOP            ;  
        
;***************************************************************************
MAIN:
        MOVLW	B'11000100'	;    
	MOVWF	PORTB           ;        
        MOVLW	B'00111101'	;    
	MOVWF	PORTA           ;
            	  ;     
	BSF	STATUS, RP0	;   1  
	MOVLW	B'00011101'	; RA<1> - , RA<4:2,0> - 
	MOVWF	TRISA		;    W  TRISA
	MOVLW	B'11000100'	;  RB<7,6,2> - , RB<0,1,3,4,5> - 
	MOVWF	TRISB		;    W  TRISB
	MOVLW	B'00111111'	;   WDT, ..-.,R-.
	MOVWF	OPTION_REG	;      OPTION
        BCF	STATUS, RP0	;   0  
        BSF     INTCON, RBIE    ;     
        BSF     INTCON, GIE     ;    
        MOVLW   D'24'     	;    
        MOVWF   r6s             ;   r6s
CYCLE:                    
       BCF     FLAG, 7          ;    
       BTFSS   PORTA, DOOR      ;  ?
       GOTO    m6               ; 
m7:
       BTFSC   FLAG, 6          ;    ?
       GOTO    m8
m9:
       BTFSC   PORTB, START_N   ; .     ?
       GOTO    m0               ; ,   
       call    D_025            ; ,    
       BTFSS   PORTB, START_N   ;   .     ?
       GOTO    m1               ; ,   
m0:       
       BTFSC   PORTA, START_P   ; .     ?
       GOTO    CYCLE            ; ,    
       call    D_025            ; ,    
       BTFSC   PORTA, START_P   ;   .     ?
       GOTO    CYCLE            ; ,    
m1:
       BTFSS   PORTA, ACC       ;    ?
       GOTO    CYCLE            ; ,    
       BTFSS   PORTA, DOOR      ;  ?
       GOTO    CYCLE            ; ,    
       
                                 ;    1- 
;-------------------------------------------------------------------------------

       MOVLW   h'01'
       CALL    JOB
       
                                 ;    2-               
;----------------------------------------------------------------------------------
     
       MOVLW   h'08'
       CALL    JOB
       
                                 ;    3-               
;----------------------------------------------------------------------------------
       
       MOVLW   h'10'
       CALL    JOB
       
       
                                ;    4-               
;----------------------------------------------------------------------------------
    
       MOVLW   h'20'
       CALL    JOB
                                ;     
;----------------------------------------------------------------------------------------
       MOVLW   h'02'
       CALL    JOB
       CLRF    PORTB
       GOTO    CYCLE        

                                ;    
;===============================================================================================
JOB:
       MOVWF   PORTB            ;  
       MOVLW   D'12'     	;    
       MOVWF   r9s              ;   r9s
m5:
       call    D_025            ;  0,5 
       call    D_025

	                  ;   
;------------------------------------------------------------------------------------ 
        CLRF    PULSE           ;  
        bcf     INTCON, T0IF    ;    TMR0
        clrf	TMR0		;  TMR0,      
	MOVLW	D'135'          ;  205,    
        MOVWF   TMR0            ;  50  (200 )
        call    D_025           ;  0,25(    )
        BTFSS   INTCON, T0IF    ;   TMR0 ?
        GOTO    m2              ; ,   
        comf    PULSE, F        ; ,    
m2:
        DECFSZ  r9s, F          ;  9      
        GOTO    m3
        
m4:
        BTFSC   FLAG, 7         ;     ?
        GOTO    sec_1
        RETURN
m3:
        BTFSS   PULSE, 7        ;  ?
        GOTO    m4              ; ,   
        GOTO    m5              ; ,    
;====================================================================================        
sec_1:
        CALL    D_025
        CALL    D_025
        CALL    D_025           ;  1 
        CALL    D_025       
        GOTO    CYCLE  
;-------------------------------------------------------------------------------  
m6:
        BSF     FLAG, 6         ;    
        BSF     PORTA, 1        ;                                         
        GOTO    m9
;------------------------------------------------------------------------------
m8:
        DECFSZ  r6s, F          ;  6      
        GOTO    m10
        MOVLW   D'24'     	;    
        MOVWF   r6s             ;   r6s
        BCF     PORTA,1         ;  
        BCF     FLAG, 6         ;    
        GOTO    m9

m10:
        CALL    D_025
        GOTO    m9 
                                 ;  
;---------------------------------------------------------------------------
STOP:
        CLRF    PORTB           ;   
        BSF     FLAG, 7         ;      
        BCF     INTCON, RBIF    ;      
        RETFIE

                         ;   250
;---------------------------------------------------------------------------
D_025:
        MOVLW 	.250      ;  250 
        MOVWF 	LOOP1
OUT:
        MOVLW   .110      ;  1 
        MOVWF   LOOP2
IN:
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        DECFSZ  LOOP2, F
        GOTO 	IN
        DECFSZ  LOOP1, F
        GOTO 	OUT
        RETURN
;--------------------------------------------------------------------------------

                  
        End
          
          
